
package jsetl.test.CP;

import jsetl.*;
import jsetl.exception.Failure;

/*
 *             Prova constraint in su CP
 */

class Constraint_in_CP {
    public static void main (String[] args) throws Failure {
    	Solver solver = new Solver();
		LSet A = LSet.empty().ins(1).ins(2);
		LSet B = LSet.empty().ins(3).ins(4);
		CP cp = new CP(A,B);    // cp = {1,2} x {3,4}
		LPair x = new LPair(1,3);
		x.setName("x").output();
		cp.setName("cp").output();
		solver.solve(x.in(cp));  // [1,3] in cp
		
		solver.clearStore();
		LVar Y1 = new LVar("Y1");
		LVar Y2 = new LVar("Y2");
		LPair Y = new LPair(Y1,Y2);
		Y.output();
		cp.output();
		solver.solve(Y.in(cp));  // [X,Y] in cp
		Y1.output();
		Y2.output();
		solver.nextSolution();
		Y1.output();
		Y2.output();
		solver.nextSolution();
		Y1.output();
		Y2.output();
		solver.nextSolution();
		Y1.output();
		Y2.output();
		
		solver.clearStore();
		LVar Z = new LVar("Z");
		Z.output();
		cp.output();
		solver.solve(Z.in(cp));  // Z in cp
		Z.output();
		solver.nextSolution();
		Z.output();
		solver.nextSolution();
		Z.output();
		solver.nextSolution();
		Z.output();
		
		solver.clearStore();
		LPair p = new LPair(new LVar(),new LVar());
		LVar W = new LVar("W",p);		
		W.output();
		cp.output();
		solver.solve(W.in(cp));  // W in cp
		W.output();
		solver.nextSolution();
		W.output();
		solver.nextSolution();
		W.output();
		solver.nextSolution();
		W.output();
		
		
    }
}

/* Prova esecuzione:
x = [1,3]
cp = {2,1} x {4,3}

? = [_Y1,_Y2]
cp = {2,1} x {4,3}
Y1 = 2
Y2 = 4
Y1 = 2
Y2 = 3
Y1 = 1
Y2 = 4
Y1 = 1
Y2 = 3

Z = unknown
cp = {2,1} x {4,3}
Z = [2,4]
Z = [2,3]
Z = [1,4]
Z = [1,3]

W = [_?,_?]
cp = {2,1} x {4,3}
W = [2,4]
W = [2,3]
W = [1,4]
W = [1,3]
*/
