package jsetl.test.CP;

import static org.junit.Assert.assertTrue;

import jsetl.exception.Failure;
import org.junit.*;
import jsetl.*;

public class ProvaSizeCP {
	
	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}
	
	//size({a,b} x {1,2},N)   --->  N = 4
	@Test
	public void size1() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins('a').ins('b');
		LSet B = LSet.empty().ins(1).ins(2);
		CP cp = new CP(A,B);
		IntLVar N = new IntLVar();
		solver.solve(cp.size(N));
		assertTrue(N.equals(cp.getSize()));
	}
	
	//size({a,b} x {1,2},4)  --->  true
	@Test
	public void size2() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins('a').ins('b');
		LSet B = LSet.empty().ins(1).ins(2);
		CP cp = new CP(A,B);
		int N = 4;
		solver.solve(cp.size(N));
	}
	
	//size({a,b} x {1,2},2)  --->  false
	@Test(expected = Failure.class)
	public void size3() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins('a').ins('b');
		LSet B = LSet.empty().ins(1).ins(2);
		CP cp = new CP(A,B);
		int N = 2;
		solver.solve(cp.size(N));
	}
	
	//size({} x {1,2}),N)  --->  N = 0
	@Test
	public void size4() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty();
		LSet B = LSet.empty().ins(1).ins(2);
		IntLVar N = new IntLVar();
		CP cp = new CP(A,B);
		solver.solve(cp.size(N));
		assertTrue(N.equals(cp.getSize()));
	}
	
	//size(A x B,0)  --->  A = {}, B = {}
	@Test
	public void size5() throws Throwable {
		Solver solver = new Solver();
		LSet A = new LSet();
		LSet B = new LSet();
		CP cp = new CP(A,B);
		IntLVar N = new IntLVar(0);
		solver.solve(cp.size(N));
		assertTrue( N.equals(cp.getSize()) );
	}
	
	//size(A x B,2)  
    //--->  A = {_N3},  B = {_N2,_N1}, _N2 neq _N1
    //--->  A = {_N3,_N2},  B = {_N1}, _N3 neq _N2
	@Test
	public void size6() throws Throwable {
		Solver solver = new Solver();
		LSet A = new LSet();
		LSet B = new LSet();
		CP cp = new CP(A,B);
		IntLVar N = new IntLVar(2);
		solver.solve(cp.size(N));
	}
}
