package jsetl.test.CP;

import static org.junit.Assert.assertTrue;

import jsetl.exception.Failure;
import org.junit.*;
import jsetl.*;

public class ProvaVincoliDefiniti {
	
	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}
	
	//subset, inters, diff, less
	
	//SUBSET SUI CP (TRUE)
	@Test
	public void subsetTest1() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(2);
		LSet B = LSet.empty().ins(1).ins(2);
		LSet C = LSet.empty().ins(new LPair(2,1));
		CP cp = new CP(A,B);
		solver.solve(C.subset(cp));
	}
	
	//SUBSET SUI CP (FALSE)
	@Test(expected = Failure.class)
	public void subsetTest2() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(2);
		LSet B = LSet.empty().ins(1).ins(2);
		LSet C = LSet.empty().ins(new LPair(3,3));
		CP cp = new CP(A,B); 
		solver.solve(C.subset(cp));
	}
	
	//SUBSET CP SU SE STESSO
	@Test
	public void subsetTest3() throws Throwable {
	   Solver solver = new Solver();
	   LSet r = LSet.empty().ins(3).ins(1);
	   CP c = new CP("c",r,r);
	   solver.solve(c.subset(c));
	}              
	
	//INTERS SUI CP
	@Test
	public void intersTest1() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(2);
		LSet B = LSet.empty().ins(1).ins(2);
		LSet D = LSet.empty().ins(new LPair(2,1));
		CP cp = new CP(A,B);
		LSet C = new LSet();
		solver.solve(C.inters(cp, D));
							// INSIEME VUOTO
		solver.nextSolution();
							// COPPIA [1,2]
		solver.nextSolution();
						// COPPIA [1,2]
		solver.nextSolution();
						// UNKNOWN
	}

	//DIFF SUI CP
	@Test
	public void diffTest1() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);
		LSet B = LSet.empty().ins(3).ins(2);
		LSet C = LSet.empty().ins(new LPair(1,2));
		CP cp = new CP(A,B);
		LSet D = new LSet();
		solver.solve(cp.diff(C,D));
		assertTrue(D.equals(LSet.empty().ins(new LPair(1,3))));
	}
	
	//DIFF SUI CP
	@Test(expected = Failure.class)
	public void diffTest2() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);
		LSet B = LSet.empty().ins(3).ins(2);
		LSet C = LSet.empty().ins(new LPair(1,2));
		CP cp = new CP(A,B);
		LSet D = LSet.empty().ins(2);
		solver.solve(D.diff(cp, C));
	}
	
	//LESS SUI CP
	@Test
	public void lessTest1() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);
		LSet B = LSet.empty().ins(3).ins(2);
		CP cp = new CP(A,B);
		LSet D = new LSet();
		solver.solve(cp.less(new LPair(1,2), D));
	}
	
}












