package jsetl.test;



import jsetl.*;
import jsetl.Solver;
import junit.framework.TestCase;
import org.junit.After;
import org.junit.Before;
import org.junit.jupiter.api.Test;

public class LVarContainingLListTest extends TestCase {
	@Before
	public void setUp() {
		LObject.USEJOLLYTOKEN = true;
	}

	@After
	public void tearDown(){LObject.USEJOLLYTOKEN = false;}
	
  	@Test
	public void testIsBound01() {
		LSet set = LSet.empty().ins(LList.empty().ins(2).ins(1));
		IntLVar x = new IntLVar("x");
		IntLVar y = new IntLVar("y");
		LList p = LList.empty().ins(y).ins(x);
		
		Solver solver = new Solver();
		LVar pp = new LVar(p);
		LSet ppp = LSet.empty().ins(pp);
		solver.add(ppp.eq(set));
		
		assertEquals(true, solver.check());
		assertEquals("{[1,2]}", ppp.toString());
		

	}
	
//	@Test
	public void testIsBound02() {
		LSet set = LSet.empty().ins(LList.empty().ins(2).ins(1));
		IntLVar x = new IntLVar("x");
		IntLVar y = new IntLVar("y");
		LList p = LList.empty().ins(y).ins(x);
		
		Solver solver = new Solver();
		LSet ppp = LSet.empty().ins(p);
		solver.add(ppp.eq(set));
		
		assertEquals(true, solver.check());
		assertEquals("{[1,2]}", ppp.toString());
		

	}
	
//	@Test
	public void testLSetPartiallySpecifiedLListPartiallySpecified() {
		LSet a = new LSet().ins(new LList().ins(3).ins(2));
		LSet b = LSet.empty().ins(new LList().ins(1).ins(2)).ins(new LList().ins(3).ins(2));
		assertEquals(true,a.eq(b).check());
	}

}
