package jsetl.test;

import java.util.ArrayList;
import java.util.Vector;

import jsetl.*;

import org.junit.Test;
import junit.framework.TestCase;

public class SetIntervalTest extends TestCase {
	
	@Test
	public void
	testSetInterval1() {
		MultiInterval lb = new MultiInterval();
		MultiInterval ub = new MultiInterval(1, 4);
		SetInterval s = new SetInterval(lb, ub);
		MultiInterval a = new MultiInterval(1, 2);
		MultiInterval b = new MultiInterval(3);
		b.add(1);
		MultiInterval c = new MultiInterval(4);
		ArrayList<MultiInterval> v = new ArrayList<MultiInterval>();
		v.add(a); 
		v.add(b);
		v.add(c);
		SetInterval s1 = new SetInterval(v);
		assertTrue(s1.equals(s));
		assertTrue(s.contains(b));
		
		v.clear();
		v.add(new MultiInterval(0));
		v.add(new MultiInterval(1));
		v.add(new MultiInterval(2, MultiInterval.SUP));
		s = new SetInterval(v);
		assertEquals(s.toString(), "[{}..[0..1]]");
	}
	
	@Test
	public void
	testSetInterval2() {
		MultiInterval ub = new MultiInterval(1, 4);
		MultiInterval lb = new MultiInterval(1, 3);
		lb.remove(2);
		SetInterval s = new SetInterval(lb, ub);
		assertEquals((int) s.size(), 4);
		
		ub.remove(3);
		s = new SetInterval(lb, ub);
		assertTrue(s.isEmpty());
		
		lb = new MultiInterval();
		s = new SetInterval(lb);
		assertEquals((int) s.size(), 1);
	}
	
	@Test
	public void
	testSetInterval3() {
		MultiInterval lb = new MultiInterval(1, 2);
		MultiInterval ub = new MultiInterval(0);
		SetInterval empty = new SetInterval();
		assertEquals(empty, new SetInterval(lb, ub));
		assertEquals(empty.toString(), "{}");
		assertFalse(empty.contains(new MultiInterval()));
	}
	
}
